public class Recursion {

    /*
    Aufgabe:
        Rekursive Methoden.
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sie dürfen dabei KEINE SCHLEIFEN und KEINE GLOBALEN VARIABLEN
        (Variablen, die außerhalb eines Methodenrumpfs deklariert werden) verwenden!
        Methoden dürfen sich gegenseitig aufrufen.
        Definieren Sie aber keine zusätzlichen Hilfsmethoden.

    Punkte (maximal 27):
        9 Punkte für die Implementierung von 'replicate',
        9 Punkte für die Implementierung von 'diagonal',
        9 Punkte für die Implementierung von 'enumerateFilesystem'.
        Bewertung: für jede Methode jeweils ALLES ODER NICHTS!
        nur vollständig korrekt implementierte Methoden erhalten Punkte.
    */

    // Gibt das gegebene Zeichen c genau n-mal auf der Kommandozeile aus.
    // Wenn n gleich 0 wird nichts ausgegeben.
    // Für negative n soll das gleiche passieren wie für n gleich 0.
    // Beispiel: replicate('a',5) gibt folgendes aus: aaaaa
    // Hinweis: nach der Ausgabe soll KEIN Zeilenumbruch erfolgen.
    public static void replicate(char c, int n) {
        if(n>0){
            System.out.print(c);
            replicate(c, n-1);
        }

    }

    // Gibt alle Zahlen absteigend von n bis m zeilenweise mit jeweils um 1 größer
    // werdenen Anzahl von führenden '_' aus.
    // Ist m > n wird nichts ausgegeben.
    // Beispiel: diagonal(5, 10) gibt folgendes aus:
    // 10
    // _9
    // __8
    // ___7
    // ____6
    // _____5
    //
    // Hinweis: Hier darf 'replicate' benutzt werden.
    public static void diagonal(int m, int n) {
        if(m<=n){
            if(n==m){
                replicate('_', n-m);

            }

            System.out.println(n);
        }

    }

    // Gegeben ist ein Array an Dateisystemeinträgen die formatiert ausgegeben
    // werden sollen. Beispiel:
    //
    //     String[] entries = {"readme.md", "src/", "Main.java", "Test.java",
    //                         "..", "build/", "..", ".gitignore"};
    //     enumerateFilesystem(entries, 0, 0);
    //
    // liefert folgende Ausgabe:
    //
    // readme.md
    // src/
    // __Main.java
    // __Test.java
    // build/
    // .gitignore
    //
    // Insbesondere gilt:
    //
    //   - Jeder String im gegebenen Array wird in einer eigenen Zeile
    //     ausgegeben, beginnend mit Element i, wobei jede Zeile mit n
    //     mal dem Zeichen '_' beginnt.
    //
    //   - Wenn ein Element mit "/" endet, dann wird für jedes darauf folgende
    //     Element der Einrückungsgrad um zwei mal '_' erhöht.
    //
    //   - Wenn ein Element gleich ".." ist, dann wird es nicht ausgegeben,
    //     aber der Einrückungsgrad aller darauf folgenden Elemente wird um
    //     zwei '_' verringert.
    //
    // Hinweise:
    //
    //   - Sie können replicate als Teil ihrer Implementierung verwenden
    //     (auch wenn Sie replicate nicht implementiert haben).
    //
    //   - Verwenden Sie die Methoden charAt oder endsWith des String-Typs
    //     um das Ende von Strings zu überprüfen,
    //     und equals um die Gleichheit von Strings zu überprüfen.
    //
    public static void enumerateFilesystem(String[] entries, int i, int n) {
        if (i < 0 || i >= entries.length) {
            return;
        }
        // TODO: implementieren der restlichen Funktion mittels Rekursion

    }

    // Diese Methode können Sie zum Testen nutzen. Geht nicht in die Beurteilung ein.
    public static void main(String[] args) {
        replicate('a', 5);
        System.out.println();
        diagonal(8,10);

    }

}

